﻿<Graph ClassName="RQRequisitionEntryExtPB" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PX.Data;
using PX.Objects.PO;
using PX.Objects.AP;
using PX.Objects.CR;
using PX.Objects.CM;
using PX.Objects.CS;
using System.Collections;
using PX.Data.DependencyInjection;
using PX.LicensePolicy;
using PX.Objects.EP;
using PX.Objects.IN;
using PX.Objects.SO;
using PX.Objects.AR;
using PX.Objects.Common.Extensions;
using PX.Objects.GL;
using PX.TM;
using PX.Objects.Common;
using PX.Objects.Common.Bql;
using PX.Objects;
using PX.Objects.RQ;
using PBBidding;

namespace PX.Objects.RQ
{
    public class RQRequisitionEntryExtPB : PXGraphExtension<RQRequisitionEntry>
    {
        public delegate IEnumerable CreatePOOrderDelegate(PXAdapter adapter);
        [PXOverride]
        public IEnumerable CreatePOOrder(PXAdapter adapter, CreatePOOrderDelegate baseMethod)
        {
            foreach (RQRequisition line in baseMethod(adapter))
            {
                baseMethod(adapter);
                var doc = Base.Document.Current;
                var docExt = PXCache<RQRequisition>.GetExtension<RQRequisitionExtPB>(doc);
                PBBid sourceBid = PXSelect<
                    PBBid,
                    Where<PBBid.bidID, Equal<Current<RQRequisitionExtPB.usrSourceBidID>>>>
                    .Select(Base);

                var graph = PXGraph.CreateInstance<POOrderEntry>();
                foreach (RQRequisitionOrder selectPO in PXSelect<
                    RQRequisitionOrder,
                    Where<RQRequisitionOrder.reqNbr, Equal<Required<RQRequisitionOrder.reqNbr>>>>
                    .Select(Base, doc.ReqNbr))
                {
                    if (selectPO != null)
                    {
                        graph.Document.Current = graph.Document.Search<POOrder.orderNbr>(selectPO.OrderNbr, selectPO.OrderType);
                        if (docExt.UsrTaxZoneID != null)
                        {
                            graph.Document.Cache.SetValueExt<POOrder.taxZoneID>(graph.Document.Current, docExt.UsrTaxZoneID);
                            graph.Document.Update(graph.Document.Current);
                        }

                        if (sourceBid != null)
                        {
                            graph.Document.Cache.SetValueExt<POOrderExtPB.usrRemarks>(graph.Document.Current, sourceBid.Remarks);
                            graph.Document.Update(graph.Document.Current);
                        }

                        graph.Persist();
                    }
                }

                yield return line;
            }
        }
    }
}]]></CDATA>
</Graph>